/*******************************************************************************
 * Copyright (c) 2000, 2005 QNX Software Systems and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     QNX Software Systems - Initial API and implementation
 *******************************************************************************/
package com.redhat.eclipse.cdt.autotools;

import com.redhat.eclipse.cdt.autotools.internal.MakeTargetManager;
import org.eclipse.core.resources.IProject;

public class AutotoolsMakeTargetManager extends MakeTargetManager {
	private String TARGET_BUILDER_ID = "genmakebuilder";
	
	public AutotoolsMakeTargetManager() {
	}

	public boolean hasTargetBuilder(IProject project) {
		return AutotoolsMakefileBuilder.hasTargetBuilder(project);
	}
	
	public String[] getTargetBuilders(IProject project) {
		if (hasTargetBuilder(project)) {
			String[] ids = new String[] {TARGET_BUILDER_ID};
			return ids;
		}
		return new String[0];
	}
	
	public String getBuilderID(String targetBuilderID) {
		if (targetBuilderID.equals(TARGET_BUILDER_ID))
			return AutotoolsMakefileBuilder.getBuilderId();
		return null;
	}
}
