package com.redhat.eclipse.cdt.autotools;

import java.util.HashMap;

import org.eclipse.cdt.core.AbstractCExtension;
import org.eclipse.cdt.core.parser.IScannerInfo;
import org.eclipse.cdt.core.parser.IScannerInfoChangeListener;
import org.eclipse.cdt.core.parser.IScannerInfoProvider;
import org.eclipse.core.resources.IResource;

public class AutotoolsScannerInfoProvider extends AbstractCExtension implements IScannerInfoProvider {

	static private HashMap infoCollection = new HashMap();
	static public final String INTERFACE_IDENTITY = 
		AutotoolsPlugin.PLUGIN_ID + "." + "AutotoolsScannerInfoProvider"; // $NON-NLS-1$

	public IScannerInfo getScannerInformation(IResource resource) {
		IResource res = AutotoolsScannerInfo.followIncludeChain(resource);
		AutotoolsScannerInfo info = (AutotoolsScannerInfo)infoCollection.get(res);
		if (info == null) {
			info = new AutotoolsScannerInfo(res);
			infoCollection.put(res, info);
		}
		return info; 
	}

	public void subscribe(IResource resource,
			IScannerInfoChangeListener listener) {
		AutotoolsScannerInfo info = (AutotoolsScannerInfo)getScannerInformation(resource);
		info.addListener(listener);
	}

	public void unsubscribe(IResource resource,
			IScannerInfoChangeListener listener) {
		AutotoolsScannerInfo info = (AutotoolsScannerInfo)getScannerInformation(resource);
		info.removeListener(listener);
	}
}
